#ifndef _DEMOS_H
#define _DEMOS_H

#include "demowindow.h"

typedef sigc::slot<Gtk::Window*> type_slotDo;

struct Demo
{
  const char* title;
  const char* filename;
  //GDoDemoFunc func;
  type_slotDo slot; //The method to call.
  Demo* children;
};

Gtk::Window* do_drawables();
Gtk::Window* do_Viewbox();
Gtk::Window* do_AffineAnimator();
Gtk::Window* do_FreehandSketcher();
Gtk::Window* do_Selector();
Gtk::Window* do_Translator();
Gtk::Window* do_Rotator();
Gtk::Window* do_Scaler();
Gtk::Window* do_Handlebox_Scaler();

Demo controllers[] = {
  { "Freehand Sketcher", "example_freehandsketcher.cpp",  sigc::ptr_fun(&do_FreehandSketcher), 0 },
  { "Selector", "example_selector.cpp",  sigc::ptr_fun(&do_Selector), 0 },
  { "Translator", "example_translator.cpp",  sigc::ptr_fun(&do_Translator), 0 },
  { "Rotator", "example_rotator.cpp",  sigc::ptr_fun(&do_Rotator), 0 },
  { "Scaler", "example_scaler.cpp",  sigc::ptr_fun(&do_Scaler), 0 },
  { "Handlebox Scaler", "example_handlebox_scaler.cpp",  sigc::ptr_fun(&do_Handlebox_Scaler), 0 },
  { 0, 0, type_slotDo(), 0 }
};


// Demo comboboxes[] = {
//   { "Line Cap Combo Box", "example_linecapcombobox.cpp",  sigc::ptr_fun(&do_LineCapComboBox), 0 },
//   { "Line Join Combo Box", "example_linejoincombobox.cpp",  sigc::ptr_fun(&do_LineJoinComboBox), 0 },
//   { "Line Width Combo Boxes", "example_linewidthcombobox.cpp",  sigc::ptr_fun(&do_LineWidthComboBox), 0 },
//   { "Marker Combo Box", "example_markercombobox.cpp",  sigc::ptr_fun(&do_MarkerComboBox), 0 },
//   { 0, 0, type_slotDo(), 0 }
// };

Demo testgtk_demos[] =
{
  { "Drawables", "example_drawables.cpp", sigc::ptr_fun(&do_drawables), 0 },
  { "Affine Animator", "example_affineanimator.cpp",  sigc::ptr_fun(&do_AffineAnimator), 0 },
  { "View Boxes", "example_viewbox.cpp",  sigc::ptr_fun(&do_Viewbox), 0 },
  { "Controllers", "", type_slotDo(), controllers },
//   { "Combo Boxes", "", type_slotDo(), comboboxes },
  { 0, 0, type_slotDo(), 0 }
};

#endif //_DEMOS_H
