/* Marker Widget
 *
 * Marker widgets provide the user with a means of selecting various attributes
 * of markers including the fill color, outline color, width, height, line
 * width, line cap, and line join.
 *
 * In addition to setting the attributes, a preview widget is also available.
 */

#include "gtkmm.h"

#include <papyrusmm/markerwidget.h>

class Example_MarkerWidget : public Gtk::Window
{
  public:
    Example_MarkerWidget();
    virtual ~Example_MarkerWidget();

  protected:
  //Member widgets:
    PapyrusGtk::MarkerWidget m_MarkerWidget;
};

//Called by DemoWindow;
Gtk::Window* do_MarkerWidget()
{
  return new Example_MarkerWidget();
}

Example_MarkerWidget::Example_MarkerWidget()
{

  set_title("Marker Widget");
  set_border_width(10);

  this->add( m_MarkerWidget );

  show_all();
}

Example_MarkerWidget::~Example_MarkerWidget()
{
}
