/* Viewports
 *
 * A Viewport widget displays a Papyrus Canvas, and is roughly similar in concept to a
 * Gtk DrawingArea or a Gnome Canvas object. The Viewport inherits from Gtk::EventBox
 * so it is capable of capturing user input.
 */

#include "gtkmm.h"

#include <papyrus.h>
#include <papyrusmm/viewport.h>

class Example_Viewport : public Gtk::Window
{
  public:
    Example_Viewport();
    virtual ~Example_Viewport();

  protected:
  //Member widgets:
    PapyrusGtk::Viewport m_Viewport;
};

//Called by DemoWindow;
Gtk::Window* do_Viewport()
{
  return new Example_Viewport();
}

Example_Viewport::Example_Viewport()
{

  set_title("Viewport Example");
  set_border_width(10);

	m_Viewport.set_size_request(200, 200);
	m_Viewport.canvas()->add( Papyrus::example_group( true, true ) );

  this->add( m_Viewport );

  show_all();
}

Example_Viewport::~Example_Viewport()
{
}
