/***************************************************************************
*   Copyright (C) 2006 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef PAPYRUSHSBA_H
#define PAPYRUSHSBA_H

#include <cairomm/pattern.h>

namespace Papyrus {

class RGBA;

  /**
   * A structure containing a HSBA value.
   */

struct HSBA {
  HSBA(double h=0.0, double s=0.0, double b=0.0, double a=1.0);

  HSBA(const RGBA& rgb);

  double hue, saturation, brightness, alpha;

  double operator[](unsigned index);

  HSBA& operator=(const RGBA& rgb);

  operator RGBA();

  operator Cairo::RefPtr<Cairo::Pattern>();

  };

  void rgb_to_hsb(double rgb_r, double rgb_g, double rgb_b,
                  double& hsb_h, double& hsb_s, double& hsb_b);

  void hsb_to_rgb(double hsb_h, double hsb_s, double hsb_b,
                  double& rgb_r, double& rgb_g, double& rgb_b);


}

#endif
