/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#include "polygon.h"

namespace Papyrus {

Polygon::Polygon(Vertices vertices):
    Polyline(vertices) {
  set_use_outline( false );
    }

    Polygon::pointer Polygon::create(Vertices vertices) {
        return Polygon::pointer( new Polygon(vertices) );
    }


    Polygon::~Polygon() {}

    void Polygon::set_line_style(const LineStyle& line_style) {
        set_outline( line_style, true );
    }

    void Polygon::draw_shape( Cairo::RefPtr<Cairo::Context> cairo) {

        if (m_vertices.size() < 3)
            return;
        cairo->move_to( m_vertices[0].x, m_vertices[0].y);
        for (Vertices::iterator i = m_vertices.begin()+1; i != m_vertices.end(); i++) {
          if ( i->relative )
            cairo->rel_line_to( i->x, i->y );
          else
            cairo->line_to( i->x, i->y);
        }
        cairo->close_path();
    }

}
